package com.cirmuller.maidaddition.entity.behaviour;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.github.tartaricacid.touhoulittlemaid.entity.chatbubble.IChatBubbleData;
import com.github.tartaricacid.touhoulittlemaid.entity.chatbubble.implement.TextChatBubbleData;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import com.google.common.collect.ImmutableMap;
import com.simibubi.create.content.kinetics.base.DirectionalKineticBlock;
import com.simibubi.create.content.kinetics.crank.HandCrankBlock;
import com.simibubi.create.content.kinetics.crank.HandCrankBlockEntity;
import java.util.Map;
import java.util.Random;
import javax.annotation.Nullable;
import net.minecraft.core.Direction;
import net.minecraft.network.chat.Component;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.ai.behavior.Behavior;
import net.minecraft.world.entity.ai.behavior.BehaviorUtils;
import net.minecraft.world.entity.ai.behavior.BlockPosTracker;
import net.minecraft.world.entity.ai.behavior.PositionTracker;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraft.world.entity.ai.memory.WalkTarget;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.phys.Vec3;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class UseHandCrankBehaviour extends Behavior<EntityMaid> {
  float speedModifier;
  
  HandCrankBlockEntity handCrankBlockEntity;
  
  Logger logger = LogManager.getLogger("maidaddition");
  
  int bubbleTick;
  
  public static Random random = new Random();
  
  static String[] bubbles = new String[] { "message.maidaddition.996_is_felicity", "message.maidaddition.you_will_be_grateful_to_yourself_tomorrow_for_struggling_today", "message.maidaddition.thanks_for_providing_work_by_player", "message.maidaddition.struggle_for_owner" };
  
  private static final int bubbleInterval = 600;
  
  public UseHandCrankBehaviour(float speedModifier) {
    super((Map)ImmutableMap.of(MemoryRegistry.HAND_CRANK_TARGET.get(), MemoryStatus.VALUE_PRESENT, MemoryModuleType.f_26370_, MemoryStatus.VALUE_ABSENT));
    this.speedModifier = speedModifier;
    this.bubbleTick = 0;
  }
  
  protected void start(ServerLevel serverLevel, EntityMaid entityMaid, long gameTimeIn) {
    entityMaid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.HAND_CRANK_TARGET.get()).ifPresent(target -> {
          BehaviorUtils.m_22617_((LivingEntity)entityMaid, target.m_58899_(), this.speedModifier, 0);
          this.handCrankBlockEntity = target;
          Direction direction = (Direction)this.handCrankBlockEntity.m_58900_().m_61143_((Property)DirectionalKineticBlock.FACING);
          entityMaid.m_6274_().m_21879_(MemoryModuleType.f_26371_, new BlockPosTracker(this.handCrankBlockEntity.m_58899_()));
          switch (null.$SwitchMap$net$minecraft$core$Direction[direction.ordinal()]) {
            default:
              throw new IncompatibleClassChangeError();
            case 3:
            
            case 4:
            
            case 5:
            
            case 2:
            
            case 6:
            
            case 1:
              break;
          } 
          BlockPosTracker blockPosTracker = new BlockPosTracker(this.handCrankBlockEntity.m_58899_().m_7495_());
          entityMaid.m_6274_().m_21879_(MemoryModuleType.f_26370_, new WalkTarget((PositionTracker)blockPosTracker, this.speedModifier, 0));
        });
  }
  
  protected void tick(ServerLevel serverLevel, EntityMaid entityMaid, long gameTimeIn) {
    if (this.handCrankBlockEntity != null && 
      !this.handCrankBlockEntity.m_58901_())
      if (isCloserThan(new Vec3(this.handCrankBlockEntity
            .m_58899_().m_123341_(), this.handCrankBlockEntity.m_58899_().m_123342_(), this.handCrankBlockEntity.m_58899_().m_123343_()), new Vec3(entityMaid
            .m_20185_(), entityMaid.m_20186_(), entityMaid.m_20189_()), 2.0F, 2.0F)) {
        this.logger.debug(String.format("The speed of handcrank which is used by maid %d is %f", new Object[] { Integer.valueOf(entityMaid.m_19879_()), Float.valueOf(this.handCrankBlockEntity.getGeneratedSpeed()) }));
        Direction direction = (Direction)this.handCrankBlockEntity.m_58900_().m_61143_((Property)HandCrankBlock.FACING);
        switch (null.$SwitchMap$net$minecraft$core$Direction[direction.ordinal()]) {
          case 1:
          case 2:
          case 3:
            this.handCrankBlockEntity.turn((this.handCrankBlockEntity.getSpeed() > 0.01D));
            entityMaid.m_6674_(InteractionHand.MAIN_HAND);
            break;
          default:
            this.handCrankBlockEntity.turn((this.handCrankBlockEntity.getSpeed() < -0.01D));
            entityMaid.m_6674_(InteractionHand.MAIN_HAND);
            break;
        } 
        this.bubbleTick++;
        if (this.bubbleTick == 600) {
          this.bubbleTick = 0;
          int randomIndex = random.nextInt(bubbles.length);
          Component component = getChatBubbleComponent(entityMaid, randomIndex);
          if (component != null)
            entityMaid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(component)); 
        } 
      }  
    super.m_6725_(serverLevel, (LivingEntity)entityMaid, gameTimeIn);
  }
  
  protected boolean canStillUse(ServerLevel serverLevel, EntityMaid entityMaid, long gameTimeIn) {
    if (!this.handCrankBlockEntity.m_58901_())
      if (isCloserThan(new Vec3(this.handCrankBlockEntity
            .m_58899_().m_123341_(), this.handCrankBlockEntity.m_58899_().m_123342_(), this.handCrankBlockEntity.m_58899_().m_123343_()), new Vec3(entityMaid
            .m_20185_(), entityMaid.m_20186_(), entityMaid.m_20189_()), 2.0F, 4.0F))
        return true;  
    this.handCrankBlockEntity = null;
    return false;
  }
  
  protected boolean m_7773_(long gameTimeIn) {
    return false;
  }
  
  protected boolean checkExtraStartConditions(ServerLevel serverLevel, EntityMaid entityMaid) {
    return true;
  }
  
  private boolean isCloserThan(Vec3 a, Vec3 b, float horizontal, float vertical) {
    return ((a.f_82479_ - b.f_82479_) * (a.f_82479_ - b.f_82479_) + (a.f_82481_ - b.f_82481_) * (a.f_82481_ - b.f_82481_) <= (horizontal * horizontal) && Math.abs(a.f_82480_ - b.f_82480_) <= vertical);
  }
  
  @Nullable
  private Component getChatBubbleComponent(EntityMaid maid, int index) {
    ServerPlayer owner = (ServerPlayer)maid.m_269323_();
    if (owner == null)
      return null; 
    switch (index) {
      case 2:
      
      case 3:
      
    } 
    return 




      
      (Component)Component.m_237115_(bubbles[index]);
  }
}
